﻿-- Addon:	ChiBar: GUI-creating part
-- Author:	Fushui(EU-Azshara)


-- Disables Addons, if Character is no Monk
if select(2, UnitClass("player")) ~= "MONK" then
    return
end



local VERSIONNUMBER = GetAddOnMetadata("ChiBar", "Version")


------------------------------------------
--		Creating Varibales 				--
------------------------------------------

-- Creating MainArray for all da fun, mon!
ChiBar = {}
-- Creating MainFrame
ChiBar.mainFrame = CreateFrame("Frame", "ChiBarFrame", UIParent)
-- Some Constants
local ICON = "|TInterface\\Addons\\ChiBar\\images\\MonkLightPower:15:15|t"
ChiBar.VERSIONTEXT_1 = ICON.." |cff00FF96ChiBar Version "..VERSIONNUMBER.." "..ICON
ChiBar.VERSIONTEXT_2 = "|cff00FF96Coding: Fushui(EU-Azshara)   Textures: Ayliara(EU-Azshara)"
ChiBar.BUBBLEDIM = 50
ChiBar.TEXTURE_NAMES = {
	"Chinese Dragon",
	"KittyFox",
	"Minimalistic 1",
	"Minimalistic 2",
	"Rhombus 1",
	"Rhombus 2",
	"Sphere Simple",
	"Sphere Sun 1",
	"Sphere Sun 2",
	"Square Simple",
	"Yin & Yang 1",
	"Yin & Yang 2",
	"Yin & Yang 3",
	}
ChiBar.TEXTURE_PATH = {
	"chinese_dragon",
	"kittyfox",
	"minimalistic_1",
	"minimalistic_2",
	"rhombus_1",
	"rhombus_2",
	"sphere_simple",
	"sphere_sun_1",
	"sphere_sun_2",
	"square_simple",
	"yin_yang_1",
	"yin_yang_2",
	"yin_yang_3",
	}
ChiBar.textures = {}
local index = 1
for index = 1, #ChiBar.TEXTURE_NAMES do
	ChiBar.textures[((index*2)-1)] =
		"Interface\\Addons\\ChiBar\\images\\"..ChiBar.TEXTURE_PATH[index].."_empty.tga"
	ChiBar.textures[(index*2)] =
		"Interface\\Addons\\ChiBar\\images\\"..ChiBar.TEXTURE_PATH[index].."_glow.tga"
end


------------------------------------------
--		GUI								--
------------------------------------------

function ChiBar:createUI()
	-- Creating SubFrame
	ChiBar.Bubbles = {}
	for index = 1, 5 do
		ChiBar.Bubbles[index] = CreateFrame("Frame", "ChiBubble1"..index, ChiBar.mainFrame)
	end

	-- Creating Textures
	ChiBar.BGTexture = ChiBar.mainFrame:CreateTexture("BGTexture")
	ChiBar.BGTexture2 = ChiBar.Bubbles[1]:CreateTexture("BGTexture2")
	ChiBar.BGTexture:SetTexture(220, 220, 220, 0.3)
	ChiBar.BGTexture2:SetTexture(250, 250, 250, 0.7)
	ChiBar.BGTexture2:SetAllPoints(ChiBar.mainFrame)
	ChiBar.BGTexture:Hide()
	ChiBar.BGTexture2:Hide()
	ChiBar.Textures0 = {}
	ChiBar.Textures1 = {}
	for index = 1, 5 do
		ChiBar.Textures0[index] = ChiBar.Bubbles[index]:CreateTexture("ChiTexture"..index.."0")
		ChiBar.Textures1[index] = ChiBar.Bubbles[index]:CreateTexture("ChiTexture"..index.."1")
	end
	
	-- 
	ChiBar:updateLayerLevel()
	
	-- Orientation
	ChiBar:settingUpOrientation()
	
	-- Setting proberties of the mainFrames
	ChiBar.mainFrame:SetWidth(ChiBar.BUBBLEDIM)
	ChiBar.mainFrame:SetHeight(ChiBar.BUBBLEDIM)
	ChiBar.mainFrame:SetPoint(ChiBarDB.from, UIParent, ChiBarDB.to, ChiBarDB.x, ChiBarDB.y)
	ChiBar.mainFrame:SetScale(ChiBarDB.scale)
	ChiBar:adjustOpacity(ChiBarDB.alpha1, ChiBarDB.alpha2)
	ChiBar:changeColor()
	ChiBar.mainFrame:RegisterForDrag("LeftButton")
	ChiBar.mainFrame:SetMovable(false)

	-- Setting proberties of the subFrames
	for index = 1, 5 do
		ChiBar.Bubbles[index]:SetHeight(ChiBar.BUBBLEDIM)
		ChiBar.Bubbles[index]:SetWidth(ChiBar.BUBBLEDIM)
	end	
	
	-- Setting proberties of the Frames
	for index = 1, 5 do
		ChiBar.Textures0[index]:SetAllPoints(ChiBar.Bubbles[index])
		ChiBar.Textures1[index]:SetAllPoints(ChiBar.Bubbles[index])
		ChiBar.Textures0[index]:SetTexture(ChiBar.textures[((ChiBarDB.savedTexture*2)-1)])
		ChiBar.Textures1[index]:SetTexture(ChiBar.textures[(ChiBarDB.savedTexture*2)])
		ChiBar.Textures1[index]:Hide()
	end
end

-- Set the orientation of ChiBar
function ChiBar:settingUpOrientation()
	if ChiBarDB.grow1 then
		ChiBar.BGTexture:SetWidth(5*ChiBar.BUBBLEDIM)
		ChiBar.BGTexture:SetHeight(ChiBar.BUBBLEDIM)
		ChiBar.orientation1 = 0
		if ChiBarDB.grow2 then
			ChiBar.orientation2 = 1
		else
			ChiBar.orientation2 = -1
		end
	else
		ChiBar.BGTexture:SetWidth(ChiBar.BUBBLEDIM)
		ChiBar.BGTexture:SetHeight(5*ChiBar.BUBBLEDIM)
		ChiBar.orientation1 = 1
		if ChiBarDB.grow2 then	
			ChiBar.orientation2 = 1
		else
			ChiBar.orientation2 = -1
		end
	end
	
	local add = 0
	if UnitPowerMax("player", 12) == 4 then add = ChiBar.BUBBLEDIM/2 end
	
	ChiBar.BGTexture:SetPoint("CENTER", ChiBar.Bubbles[3], "CENTER", (-add)*(1-ChiBar.orientation1)*ChiBar.orientation2, (-add)*ChiBar.orientation1*ChiBar.orientation2)
	for index = 0, 4 do
		local coord = (index*ChiBar.BUBBLEDIM+add)*ChiBar.orientation2
		ChiBar.Bubbles[index+1]:SetPoint("CENTER", ChiBar.mainFrame, "CENTER", coord*(1-ChiBar.orientation1), coord*ChiBar.orientation1)
	end
end


------------------------------------------
--		End of Script					--
------------------------------------------